-- Author      : Nogarder
-- Create Date : 7/22/2018 3:25:54 AM

local NPA_Color_GetColorByPower=NPA.Color.GetColorByPower
local NPA_NamePlateDataParser_AddElements=NPA.NamePlateDataParser.AddElements

local NPA_FrameMacro_SetFrameTimer=NPA.FrameMacro.SetFrameTimer

local NPA_NumberManager_SetNumber=NPA.NumberManager.SetNumber
local NPA_NumberManager_SetNumberColor=NPA.NumberManager.SetNumberColor

local NPA_BarManager_SetBarGroupColor=NPA.BarManager.SetBarGroupColor
local NPA_BarManager_SetBarGroup=NPA.BarManager.SetBarGroup
--
local SecondaryPowerList={
		[0] = "SecondaryPower_Mana",
		[1] = "SecondaryPower_Rage",
		[2] = "SecondaryPower_Focus",
		[3] = "SecondaryPower_Energy",
		[4] = "SecondaryPower_ComboPoints",
		[5] = "SecondaryPower_Runes",
		[6] = "SecondaryPower_RunicPower",
		[7] = "SecondaryPower_SoulShards",
		[8] = "SecondaryPower_Eclipse",
		[9] = "SecondaryPower_HolyPower",
		[12] = "SecondaryPower_Chi",
		[13] = "SecondaryPower_Insanity",
		[16] = "SecondaryPower_ArcaneCharges",
}
for index,regname in pairs(SecondaryPowerList) do
	NPA.NamePlateModuleManager.RegisterDataModule("BarGroup",regname,function(framedata,bargroupframe,setting)
		--add event elements
 		--hook name update
		NPA_NamePlateDataParser_AddElements(framedata,bargroupframe,"SecondaryPower_Updated",function(framedata,unitdata)
			if(unitdata.SecondaryPowerUpdated and index~=unitdata.PowerType and unitdata.SecondaryPower[index])then
				local powerinfo = unitdata.SecondaryPower[index]
				bargroupframe:Show()
				--
				NPA_BarManager_SetBarGroup(bargroupframe,(powerinfo.Power or 0)/(powerinfo.PowerMax or 1))
				if(setting.ColorMode==9)then
					local color=NPA_Color_GetColorByPower(index)
					NPA_BarManager_SetBarGroupColor(bargroupframe,color)
				end
				--set timer
				NPA_FrameMacro_SetFrameTimer(bargroupframe,unitdata.SecondaryPowerUpdated,unitdata.SecondaryPowerUpdated+1,
					function(nTime,data)
						--update alpha
						local percent=(data.EndTime-nTime)/data.Length
						bargroupframe:SetAlpha(setting.Alpha*percent)
					end,
					function()
						--hide when time out
						bargroupframe:Hide()
					end)
			else
				bargroupframe:Hide()
			end
		end)
	end)
	NPA.NamePlateModuleManager.RegisterDataModule("Number",regname,function(framedata,numberframe,setting)
		--add event elements
 		--hook name update
		NPA_NamePlateDataParser_AddElements(framedata,numberframe,"SecondaryPower_Updated",function(framedata,unitdata)
			if(unitdata.SecondaryPowerUpdated and index~=unitdata.PowerType and unitdata.SecondaryPower[index])then
				local powerinfo = unitdata.SecondaryPower[index]
				numberframe:Show()
				NPA_NumberManager_SetNumber(numberframe,powerinfo.Power or 0,powerinfo.PowerMax or 1)
				if(setting.ColorMode==9)then
					local color=NPA_Color_GetColorByPower(index)
					NPA_NumberManager_SetNumberColor(numberframe,color)
				end
				--set timer
				NPA_FrameMacro_SetFrameTimer(numberframe,unitdata.SecondaryPowerUpdated,unitdata.SecondaryPowerUpdated+1,
					function(nTime,data)
						--update alpha
						local percent=(data.EndTime-nTime)/data.Length
						numberframe:SetAlpha(setting.Alpha*percent)
					end,
					function()
						--hide when time out
						numberframe:Hide()
					end)
			else
				numberframe:Hide()
			end
		end)
	end)
	--
	NPA.NamePlateModuleManager.RegisterDataModule("TextureGroup",regname,function(framedata,textureframe,setting)
		NPA_NamePlateDataParser_AddElements(framedata,textureframe,"SecondaryPower_Updated",function(framedata,unitdata)
			if(unitdata.SecondaryPowerUpdated and index~=unitdata.PowerType and unitdata.SecondaryPower[index])then
				textureframe:Show()
				--set timer
				NPA_FrameMacro_SetFrameTimer(textureframe,unitdata.SecondaryPowerUpdated,unitdata.SecondaryPowerUpdated+1,
					function(nTime,data)
						--update alpha
						local percent=(data.EndTime-nTime)/data.Length
						textureframe:SetAlpha(setting.Alpha*percent)
					end,
					function()
						--hide when time out
						textureframe:Hide()
					end)
			else
				textureframe:Hide()
			end
		end)
	end)
end

local GetAutoSecondaryPower = function(unitdata)
	for index,_ in pairs(SecondaryPowerList) do
		if(index~=unitdata.PowerType and unitdata.SecondaryPower[index])then
			local data = unitdata.SecondaryPower[index]
			return data.Power,data.PowerMax,index
		end
	end
	return nil,1,0
end

NPA.NamePlateModuleManager.RegisterDataModule("BarGroup","SecondaryPower_Auto",function(framedata,bargroupframe,setting)
	--add event elements
 	--hook name update
	NPA_NamePlateDataParser_AddElements(framedata,bargroupframe,"SecondaryPower_Updated",function(framedata,unitdata)
		if(unitdata.SecondaryPowerUpdated)then
			local power,powermax,powertype = GetAutoSecondaryPower(unitdata)
			if(power~=nil)then
				bargroupframe:Show()
				--
				NPA_BarManager_SetBarGroup(bargroupframe,(power or 0)/(powermax or 1))
				if(setting.ColorMode==9)then
					local color=NPA_Color_GetColorByPower(powertype)
					NPA_BarManager_SetBarGroupColor(bargroupframe,color)
				end
				--set timer
				NPA_FrameMacro_SetFrameTimer(bargroupframe,unitdata.SecondaryPowerUpdated,unitdata.SecondaryPowerUpdated+1,
					function(nTime,data)
						--update alpha
						local percent=(data.EndTime-nTime)/data.Length
						bargroupframe:SetAlpha(setting.Alpha*percent)
					end,
					function()
						--hide when time out
						bargroupframe:Hide()
					end)
			else
				bargroupframe:Hide()
			end
		else
			bargroupframe:Hide()
		end
	end)
end)
NPA.NamePlateModuleManager.RegisterDataModule("Number","SecondaryPower_Auto",function(framedata,numberframe,setting)
	--add event elements
 	--hook name update
	NPA_NamePlateDataParser_AddElements(framedata,numberframe,"SecondaryPower_Updated",function(framedata,unitdata)
		if(unitdata.SecondaryPowerUpdated)then
			local power,powermax,powertype = GetAutoSecondaryPower(unitdata)
			if(power~=nil)then
				numberframe:Show()
				NPA_NumberManager_SetNumber(numberframe,power or 0,powermax or 1)
				if(setting.ColorMode==9)then
					local color=NPA_Color_GetColorByPower(powertype)
					NPA_NumberManager_SetNumberColor(numberframe,color)
				end
				--set timer
				NPA_FrameMacro_SetFrameTimer(numberframe,unitdata.SecondaryPowerUpdated,unitdata.SecondaryPowerUpdated+1,
					function(nTime,data)
						--update alpha
						local percent=(data.EndTime-nTime)/data.Length
						numberframe:SetAlpha(setting.Alpha*percent)
					end,
					function()
						--hide when time out
						numberframe:Hide()
					end)
			else
				numberframe:Hide()
			end
		else
			numberframe:Hide()
		end
	end)
end)
--
NPA.NamePlateModuleManager.RegisterDataModule("TextureGroup","SecondaryPower_Auto",function(framedata,textureframe,setting)
	NPA_NamePlateDataParser_AddElements(framedata,textureframe,"SecondaryPower_Updated",function(framedata,unitdata)
		if(unitdata.SecondaryPowerUpdated)then
			textureframe:Show()
			--set timer
			NPA_FrameMacro_SetFrameTimer(textureframe,unitdata.SecondaryPowerUpdated,unitdata.SecondaryPowerUpdated+1,
				function(nTime,data)
					--update alpha
					local percent=(data.EndTime-nTime)/data.Length
					textureframe:SetAlpha(setting.Alpha*percent)
				end,
				function()
					--hide when time out
					textureframe:Hide()
				end)
		else
			textureframe:Hide()
		end
	end)
end)
